import { Overlay } from '@angular/cdk/overlay';
import { ComponentPortal } from '@angular/cdk/portal';
import { AfterViewInit, ComponentRef, EventEmitter, Injector, OnDestroy, TemplateRef } from '@angular/core';
import { BsViewState } from '../../../../types/view-state.type';
import { BehaviorSubject, Subject } from 'rxjs';
import { OffcanvasPosition } from '../../types/position';
import { BsOffcanvasComponent } from '../offcanvas/offcanvas.component';
import * as i0 from "@angular/core";
export declare class BsOffcanvasHostComponent implements AfterViewInit, OnDestroy {
    private overlayService;
    private rootInjector;
    private portalFactory;
    constructor(overlayService: Overlay, rootInjector: Injector, portalFactory: (injector: Injector) => ComponentPortal<any>);
    content: TemplateRef<any>;
    component: ComponentRef<BsOffcanvasComponent>;
    viewInited$: BehaviorSubject<boolean>;
    state$: BehaviorSubject<BsViewState>;
    size$: BehaviorSubject<number | null>;
    position$: BehaviorSubject<OffcanvasPosition>;
    hasBackdrop$: BehaviorSubject<boolean>;
    destroyed$: Subject<unknown>;
    backdropClick: EventEmitter<MouseEvent>;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    stateChange: EventEmitter<BsViewState>;
    set state(value: BsViewState);
    get state(): BsViewState;
    set position(value: OffcanvasPosition);
    get position(): OffcanvasPosition;
    set size(value: number | null);
    get size(): number | null;
    set hasBackdrop(value: boolean);
    get hasBackdrop(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsOffcanvasHostComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsOffcanvasHostComponent, "bs-offcanvas", never, { "state": "state"; "position": "position"; "size": "size"; "hasBackdrop": "hasBackdrop"; }, { "backdropClick": "backdropClick"; "stateChange": "stateChange"; }, never, never, false>;
}
